﻿package {
	
	import com.orangesuzuki.util.timer.TimerUtil;
	import flash.display.MovieClip;
	import flash.events.Event;

	public class Main extends MovieClip {
		
		private var index:uint = 0;
		private var interval:Number = 3;
		private var itemArray:Array;
		private var f1:uint = 1;
		private var f2:uint = 2;
		
		public function Main() {
			//ステージの基準点を左上に設定します。
			stage.align = "TL";
			//拡大モードを拡大なしにします。
			stage.scaleMode = "noScale";
			
			//初期化
			init();
			
			//一定時間後にchangeという関数を実行します
			TimerUtil.call(change, this, null, interval);
		}
		
		private function init():void {
			//配列を作成します。
			itemArray = [];
			
			//for文を用い、9回くりかえし実行します。
			for (var i:uint = 0; i < 9; i++) {
				add(i);
			}
		}
		
		/**
		 * 短冊上のムービークリップを1つ生成してステージに置く関数
		 * @param	i
		 */
		private function add(i:uint):void
		{
			//ムービークリップを生成して表示します。
			var bar:Bar = new Bar();
			addChild( bar );
			bar.id = i;
			bar.x = stage.stageWidth / 2 + bar.photo.width/2 -40 - 80 * i;
			bar.y = stage.stageHeight/2-150;
			bar.f1 = f1;
			bar.f2 = f2;
			bar.photo.x = -bar.photo.width + 80 * i + 40;
			
			//配列に格納します。
			itemArray.push(bar);
			
			var photo:MovieClip = bar.photo;
			photo.gotoAndStop(f1);
			
			//回転後に特定の処理をさせるようにします。
			//flipEndイベントが呼ばれると、flipEndHandlerが実行されます。
			bar.addEventListener("flipEnd", flipEndHandler);
		}
		
		/**
		 * タイマー経過後の処理
		 */
		private function change():void
		{
			//配列に含まれるムービークリップの数だけタイマーを作り実行します。
			var len:uint = itemArray.length;
			for (var i:uint = 0; i < len; i++) {
				
				//配列とインデックスの値(i)を用い、ムービークリップを取得します。
				var bar:Bar = itemArray[i];
				
				// タイマーの設定時間を、i*0.07とすることで回転をずらします。
				TimerUtil.call(bar.flip, bar, null, i*0.07);
			}
		}
		
		/**
		 * 回転後に実行されるイベントハンドラ
		 * @param	e
		 */
		private function flipEndHandler(e:Event):void 
		{
			var bar:Bar = e.target as Bar; 
			removeChild(bar);
			
			//idが0の場合(最初の回転終了後)のみ実行します。
			if (bar.id == 0) {
				//ページ番号を次へ送ります。
				f1 = ++f1 > 5 ? 1:f1;
				f2 = ++f2 > 5 ? 1:f2;
				//配列を初期化します。
				itemArray = [];
				//インデックスを初期化します。
				index = 0;
			}
			//idが8の場合(最後の回転終了後)のみ実行します。
			if (bar.id == 8) {
				TimerUtil.call(change, this, null, interval);
			}
			
			//新たに生成します。
			add(index++);
		}
	}
	
}